package threads.with.draw;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;

public class Rajzpapir extends View implements OnTouchListener {

	// Activity kontextus, amihez kthetjk
	Context context;
	boolean isMultiTouch;
	byte ujjak_szama;
	
	
	
	// Ujjak gyjtje, 2db rints tmogatsa
	Ujj[] ujjak = {
			new Ujj(0, 0, 50, Color.YELLOW),
			new Ujj(0, 0, 50, Color.GREEN),
			new Ujj(0, 0, 50, Color.CYAN), 
			new Ujj(0, 0, 50, Color.RED),
			new Ujj(0, 0, 50, Color.WHITE)
	};
	
	// Rajzols kellkei
	Paint circlePaint = new Paint();
	Paint subCirclePaint = new Paint();
	Paint crossPaint = new Paint();
	
	public Rajzpapir(Context context) {
		super(context);
		this.context = context;		
		this.setOnTouchListener(this);
	}

	@Override
	protected void onDraw(Canvas canvas) {
		super.onDraw(canvas);
		
		canvas.save();		
		for (Ujj f : ujjak) {
			if(f.isShow()){
				// Tengelyek rajzolsa				
				crossPaint.setColor(Color.GRAY);
				crossPaint.setStrokeWidth(2);				
				canvas.drawLine(0, f.getY(), canvas.getWidth(), f.getY(), crossPaint);	// horizontal
				canvas.drawLine(f.getX(), 0, f.getX(), canvas.getHeight(), crossPaint); // vertical
				
				// Kr rajzolsa				
				circlePaint.setColor(f.getColor());
				circlePaint.setAntiAlias(true);		
				subCirclePaint.setColor(Color.BLACK);
				subCirclePaint.setAntiAlias(true);
				canvas.drawCircle(f.getX(),	f.getY(), f.getR(), circlePaint);
				canvas.drawCircle(f.getX(), f.getY(), f.getR() - 10, subCirclePaint);				
			}
		}		
		canvas.restore();		
	}

	@Override
	public boolean onTouch(View v, MotionEvent event) {		
		// Szk keresztmetszet keresse, amelyik kisebb: rints szm vagy max ujj tmogats
		ujjak_szama = (byte)Math.min(ujjak.length, event.getPointerCount());
		
		if(event.getAction() == MotionEvent.ACTION_MOVE){
			for(byte i = 0; i < ujjak_szama; i++){	
				ujjak[i].setX((int)event.getX(i));
				ujjak[i].setY((int)event.getY(i));
				ujjak[i].setShow(true);
			}			
		}
		
		if(event.getAction() == MotionEvent.ACTION_UP)
			for(byte i = 0; i < ujjak.length; i++)
				ujjak[i].setShow(false);
		
		invalidate();
		
		return true;
	}
	
	

}
